package b4a.example;


import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.B4AClass;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.debug.*;

public class speechrecognition extends B4AClass.ImplB4AClass implements BA.SubDelegator{
    private static java.util.HashMap<String, java.lang.reflect.Method> htSubs;
    private void innerInitialize(BA _ba) throws Exception {
        if (ba == null) {
            ba = new BA(_ba, this, htSubs, "b4a.example.speechrecognition");
            if (htSubs == null) {
                ba.loadHtSubs(this.getClass());
                htSubs = ba.htSubs;
            }
            if (BA.isShellModeRuntimeCheck(ba)) {
			    ba.raiseEvent2(null, true, "CREATE", true, "b4a.example.speechrecognition",
                    ba);
                return;
		    }
        }
        ba.raiseEvent2(null, true, "class_globals", false);
    }

 public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4j.object.JavaObject _jo = null;
public anywheresoftware.b4a.objects.IntentWrapper _recognizerintent = null;
public boolean _initialized = false;
public anywheresoftware.b4j.object.JavaObject _speechrecognizer = null;
public Object _target = null;
public String _lang = "";
public String _speechrecognition_name = "";
public b4a.example.main _main = null;
public b4a.example.starter _starter = null;
public String  _cancel() throws Exception{
 //BA.debugLineNum = 69;BA.debugLine="Public Sub cancel";
 //BA.debugLineNum = 70;BA.debugLine="JO.RunMethod(\"cancel\",Null)";
_jo.RunMethod("cancel",(Object[])(__c.Null));
 //BA.debugLineNum = 71;BA.debugLine="End Sub";
return "";
}
public String  _class_globals() throws Exception{
 //BA.debugLineNum = 3;BA.debugLine="Sub Class_Globals";
 //BA.debugLineNum = 4;BA.debugLine="Private JO As JavaObject";
_jo = new anywheresoftware.b4j.object.JavaObject();
 //BA.debugLineNum = 5;BA.debugLine="Private RecognizerIntent As Intent";
_recognizerintent = new anywheresoftware.b4a.objects.IntentWrapper();
 //BA.debugLineNum = 6;BA.debugLine="Private Initialized As Boolean";
_initialized = false;
 //BA.debugLineNum = 7;BA.debugLine="Private SpeechRecognizer As JavaObject";
_speechrecognizer = new anywheresoftware.b4j.object.JavaObject();
 //BA.debugLineNum = 8;BA.debugLine="Private Target As Object";
_target = new Object();
 //BA.debugLineNum = 9;BA.debugLine="Private Lang As String";
_lang = "";
 //BA.debugLineNum = 10;BA.debugLine="Private SpeechRecognition_Name As String";
_speechrecognition_name = "";
 //BA.debugLineNum = 11;BA.debugLine="End Sub";
return "";
}
public String  _destroy() throws Exception{
 //BA.debugLineNum = 65;BA.debugLine="Public Sub Destroy";
 //BA.debugLineNum = 66;BA.debugLine="JO.RunMethod(\"destroy\",Null)";
_jo.RunMethod("destroy",(Object[])(__c.Null));
 //BA.debugLineNum = 67;BA.debugLine="End Sub";
return "";
}
public String  _geterrortext(int _errorcode) throws Exception{
 //BA.debugLineNum = 99;BA.debugLine="Sub GetErrorText(ErrorCode As Int) As String";
 //BA.debugLineNum = 100;BA.debugLine="Select ErrorCode";
switch (BA.switchObjectToInt(_errorcode,(int)(BA.ObjectToNumber(_speechrecognizer.GetField("ERROR_AUDIO"))),(int)(BA.ObjectToNumber(_speechrecognizer.GetField("ERROR_CLIENT"))),(int)(BA.ObjectToNumber(_speechrecognizer.GetField("ERROR_INSUFFICIENT_PERMISSIONS"))),(int)(BA.ObjectToNumber(_speechrecognizer.GetField("ERROR_NETWORK"))),(int)(BA.ObjectToNumber(_speechrecognizer.GetField("ERROR_NETWORK_TIMEOUT"))),(int)(BA.ObjectToNumber(_speechrecognizer.GetField("ERROR_NO_MATCH"))),(int)(BA.ObjectToNumber(_speechrecognizer.GetField("ERROR_RECOGNIZER_BUSY"))),(int)(BA.ObjectToNumber(_speechrecognizer.GetField("ERROR_SERVER"))),(int)(BA.ObjectToNumber(_speechrecognizer.GetField("ERROR_SPEECH_TIMEOUT"))))) {
case 0:
 //BA.debugLineNum = 102;BA.debugLine="Return \"Audio Recording error\"";
if (true) return "Audio Recording error";
 break;
case 1:
 //BA.debugLineNum = 104;BA.debugLine="Return \"Client side error\"";
if (true) return "Client side error";
 break;
case 2:
 //BA.debugLineNum = 106;BA.debugLine="Return \"Insufficient permissions\"";
if (true) return "Insufficient permissions";
 break;
case 3:
 //BA.debugLineNum = 108;BA.debugLine="Return \"Network error\"";
if (true) return "Network error";
 break;
case 4:
 //BA.debugLineNum = 110;BA.debugLine="Return \"Network timeout\"";
if (true) return "Network timeout";
 break;
case 5:
 //BA.debugLineNum = 112;BA.debugLine="Return \"No match\"";
if (true) return "No match";
 break;
case 6:
 //BA.debugLineNum = 114;BA.debugLine="Return \"RecognitionService busy\"";
if (true) return "RecognitionService busy";
 break;
case 7:
 //BA.debugLineNum = 116;BA.debugLine="Return \"error from server\"";
if (true) return "error from server";
 break;
case 8:
 //BA.debugLineNum = 118;BA.debugLine="Return \"No speech input\"";
if (true) return "No speech input";
 break;
default:
 //BA.debugLineNum = 120;BA.debugLine="Return \"Didn't understand, please try again.\"";
if (true) return "Didn't understand, please try again.";
 break;
}
;
 //BA.debugLineNum = 122;BA.debugLine="End Sub";
return "";
}
public String  _initialize(anywheresoftware.b4a.BA _ba,Object _targetmodule,String _recognizelanguage,String _objectname) throws Exception{
innerInitialize(_ba);
Object _event = null;
 //BA.debugLineNum = 15;BA.debugLine="Public Sub Initialize(TargetModule As Object, Reco";
 //BA.debugLineNum = 18;BA.debugLine="SpeechRecognizer.InitializeStatic(\"android.speech";
_speechrecognizer.InitializeStatic("android.speech.SpeechRecognizer");
 //BA.debugLineNum = 19;BA.debugLine="JO = SpeechRecognizer.RunMethod(\"createSpeechReco";
_jo.setObject((java.lang.Object)(_speechrecognizer.RunMethod("createSpeechRecognizer",new Object[]{(Object)(_jo.InitializeContext(ba).getObject())})));
 //BA.debugLineNum = 21;BA.debugLine="If Not(IsRecognitionAvailable) Then";
if (__c.Not(_isrecognitionavailable())) { 
 //BA.debugLineNum = 22;BA.debugLine="Log(\"Speech Recognition Not Available\")";
__c.Log("Speech Recognition Not Available");
 //BA.debugLineNum = 23;BA.debugLine="ToastMessageShow(\"Speech Recognition is not Avai";
__c.ToastMessageShow("Speech Recognition is not Available",__c.True);
 //BA.debugLineNum = 24;BA.debugLine="Return";
if (true) return "";
 };
 //BA.debugLineNum = 26;BA.debugLine="SpeechRecognition_Name = ObjectName";
_speechrecognition_name = _objectname;
 //BA.debugLineNum = 27;BA.debugLine="Lang = RecognizeLanguage";
_lang = _recognizelanguage;
 //BA.debugLineNum = 28;BA.debugLine="Target = TargetModule";
_target = _targetmodule;
 //BA.debugLineNum = 29;BA.debugLine="RecognizerIntent.Initialize(\"android.speech.actio";
_recognizerintent.Initialize("android.speech.action.VOICE_SEARCH_HANDS_FREE","");
 //BA.debugLineNum = 30;BA.debugLine="RecognizerIntent.PutExtra(\"calling_package\",Appli";
_recognizerintent.PutExtra("calling_package",(Object)(__c.Application.getPackageName()));
 //BA.debugLineNum = 31;BA.debugLine="RecognizerIntent.PutExtra(\"android.speech.extra.L";
_recognizerintent.PutExtra("android.speech.extra.LANGUAGE_MODEL",(Object)("free_form"));
 //BA.debugLineNum = 34;BA.debugLine="RecognizerIntent.PutExtra(\"android.speech.extra.M";
_recognizerintent.PutExtra("android.speech.extra.MAX_RESULTS",(Object)(3));
 //BA.debugLineNum = 35;BA.debugLine="RecognizerIntent.PutExtra(\"android.speech.extras.";
_recognizerintent.PutExtra("android.speech.extras.SPEECH_INPUT_POSSIBLY_COMPLETE_SILENCE_LENGTH_MILLIS",(Object)(1000));
 //BA.debugLineNum = 36;BA.debugLine="RecognizerIntent.PutExtra(\"android.speech.extras.";
_recognizerintent.PutExtra("android.speech.extras.EXTRA_SPEECH_INPUT_COMPLETE_SILENCE_LENGTH_MILLIS",(Object)(2000));
 //BA.debugLineNum = 37;BA.debugLine="RecognizerIntent.PutExtra(\"android.speech.extras.";
_recognizerintent.PutExtra("android.speech.extras.SPEECH_INPUT_MINIMUM_LENGTH_MILLIS",(Object)(1000*10));
 //BA.debugLineNum = 39;BA.debugLine="If Lang <> \"\" Then";
if ((_lang).equals("") == false) { 
 //BA.debugLineNum = 40;BA.debugLine="RecognizerIntent.PutExtra(\"android.speech.extra.";
_recognizerintent.PutExtra("android.speech.extra.LANGUAGE",(Object)(_lang));
 };
 //BA.debugLineNum = 43;BA.debugLine="Dim Event As Object = JO.CreateEvent(\"android.spe";
_event = _jo.CreateEvent(ba,"android.speech.RecognitionListener","Received",(Object)(""));
 //BA.debugLineNum = 44;BA.debugLine="JO.RunMethod(\"setRecognitionListener\",Array(Event";
_jo.RunMethod("setRecognitionListener",new Object[]{_event});
 //BA.debugLineNum = 45;BA.debugLine="Initialized = True";
_initialized = __c.True;
 //BA.debugLineNum = 46;BA.debugLine="End Sub";
return "";
}
public boolean  _isinitialized() throws Exception{
 //BA.debugLineNum = 48;BA.debugLine="Public Sub IsInitialized As Boolean";
 //BA.debugLineNum = 49;BA.debugLine="Return Initialized";
if (true) return _initialized;
 //BA.debugLineNum = 50;BA.debugLine="End Sub";
return false;
}
public boolean  _isrecognitionavailable() throws Exception{
anywheresoftware.b4j.object.JavaObject _jo1 = null;
 //BA.debugLineNum = 53;BA.debugLine="Public Sub IsRecognitionAvailable As Boolean";
 //BA.debugLineNum = 54;BA.debugLine="Dim JO1 As JavaObject";
_jo1 = new anywheresoftware.b4j.object.JavaObject();
 //BA.debugLineNum = 55;BA.debugLine="JO1.InitializeContext";
_jo1.InitializeContext(ba);
 //BA.debugLineNum = 56;BA.debugLine="Return JO.RunMethod(\"isRecognitionAvailable\",Arra";
if (true) return BA.ObjectToBoolean(_jo.RunMethod("isRecognitionAvailable",new Object[]{(Object)(_jo1.getObject())}));
 //BA.debugLineNum = 57;BA.debugLine="End Sub";
return false;
}
public Object  _received_event(String _methodname,Object[] _args) throws Exception{
anywheresoftware.b4j.object.JavaObject _results = null;
anywheresoftware.b4a.objects.collections.List _matches = null;
 //BA.debugLineNum = 73;BA.debugLine="Private Sub Received_Event (MethodName As String,";
 //BA.debugLineNum = 74;BA.debugLine="Select MethodName";
switch (BA.switchObjectToInt(_methodname,"onBeginningOfSpeech","onEndOfSpeech","onError","onResults","onRmsChanged")) {
case 0:
 break;
case 1:
 //BA.debugLineNum = 77;BA.debugLine="If SubExists(Target, SpeechRecognition_Name & \"";
if (__c.SubExists(getActivityBA(),_target,_speechrecognition_name+"_onEndOfSpeech")) { 
 //BA.debugLineNum = 78;BA.debugLine="CallSubDelayed(Target, SpeechRecognition_Name";
__c.CallSubDelayed(getActivityBA(),_target,_speechrecognition_name+"_onEndOfSpeech");
 };
 break;
case 2:
 //BA.debugLineNum = 82;BA.debugLine="If SubExists(Target, SpeechRecognition_Name & \"";
if (__c.SubExists(getActivityBA(),_target,_speechrecognition_name+"_onError")) { 
 //BA.debugLineNum = 83;BA.debugLine="CallSubDelayed2(Target, SpeechRecognition_Name";
__c.CallSubDelayed2(getActivityBA(),_target,_speechrecognition_name+"_onError",_args[(int) (0)]);
 };
 break;
case 3:
 //BA.debugLineNum = 86;BA.debugLine="Dim Results As JavaObject = Args(0)";
_results = new anywheresoftware.b4j.object.JavaObject();
_results.setObject((java.lang.Object)(_args[(int) (0)]));
 //BA.debugLineNum = 87;BA.debugLine="Dim Matches As List = Results.RunMethod(\"getStr";
_matches = new anywheresoftware.b4a.objects.collections.List();
_matches.setObject((java.util.List)(_results.RunMethod("getStringArrayList",new Object[]{(Object)("results_recognition")})));
 //BA.debugLineNum = 88;BA.debugLine="If SubExists(Target, SpeechRecognition_Name & \"";
if (__c.SubExists(getActivityBA(),_target,_speechrecognition_name+"_onResults")) { 
 //BA.debugLineNum = 89;BA.debugLine="CallSubDelayed2(Target, SpeechRecognition_Name";
__c.CallSubDelayed2(getActivityBA(),_target,_speechrecognition_name+"_onResults",(Object)(_matches));
 };
 break;
case 4:
 //BA.debugLineNum = 92;BA.debugLine="If SubExists(Target, SpeechRecognition_Name & \"";
if (__c.SubExists(getActivityBA(),_target,_speechrecognition_name+"_onRmsChanged")) { 
 //BA.debugLineNum = 93;BA.debugLine="CallSubDelayed2(Target, SpeechRecognition_Name";
__c.CallSubDelayed2(getActivityBA(),_target,_speechrecognition_name+"_onRmsChanged",_args[(int) (0)]);
 };
 break;
}
;
 //BA.debugLineNum = 97;BA.debugLine="End Sub";
return null;
}
public String  _speechrecognition_error(int _errortype) throws Exception{
 //BA.debugLineNum = 124;BA.debugLine="Sub SpeechRecognition_Error (ErrorType As Int)";
 //BA.debugLineNum = 125;BA.debugLine="Log(\"Error: \" & ErrorType)";
__c.Log("Error: "+BA.NumberToString(_errortype));
 //BA.debugLineNum = 126;BA.debugLine="CallSub2(Main, \"ShowError\", ErrorType)";
__c.CallSubNew2(getActivityBA(),(Object)(_main.getObject()),"ShowError",(Object)(_errortype));
 //BA.debugLineNum = 127;BA.debugLine="End Sub";
return "";
}
public String  _startlistening() throws Exception{
 //BA.debugLineNum = 58;BA.debugLine="Public Sub StartListening";
 //BA.debugLineNum = 59;BA.debugLine="JO.RunMethod(\"startListening\",Array(RecognizerInt";
_jo.RunMethod("startListening",new Object[]{(Object)(_recognizerintent.getObject())});
 //BA.debugLineNum = 60;BA.debugLine="End Sub";
return "";
}
public String  _stoplistening() throws Exception{
 //BA.debugLineNum = 61;BA.debugLine="Public Sub StopListening";
 //BA.debugLineNum = 62;BA.debugLine="JO.RunMethod(\"stopListening\",Null)";
_jo.RunMethod("stopListening",(Object[])(__c.Null));
 //BA.debugLineNum = 63;BA.debugLine="End Sub";
return "";
}
public Object callSub(String sub, Object sender, Object[] args) throws Exception {
BA.senderHolder.set(sender);
if (BA.fastSubCompare(sub, "STARTLISTENING"))
	return _startlistening();
return BA.SubDelegator.SubNotFound;
}
}
