﻿Type=Service
Version=5.02
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim sr As SpeechRecognition
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	sr.Initialize(Me, "", "sr")
	
'butStart.Enabled = False

'Activity.Finish
End Sub

Sub Service_Start (StartingIntent As Intent)
If sr.IsRecognitionAvailable = False Then
	Return
End If
ToastMessageShow("Speak !", False)
 
 
 
  Dim p As Phone              'Suppress Google Voice Beep
  Dim Volu1 As Int
    Dim Wticks1 As Long
    Dim Wticks2 As Long
  
        Volu1 = p.GetVolume(p.VOLUME_MUSIC)
        p.SetVolume(p.VOLUME_MUSIC, 0, False)
       ' CallSub(Starter, "StartListening")
      sr.startListening
	  
	    Wticks1 = DateTime.Now
        Wticks2 = 0
        Do While Wticks2 < (Wticks1+800)
          Wticks2 = DateTime.Now
          DoEvents
        Loop
        p.SetVolume(p.VOLUME_MUSIC, Volu1, False)


'sr.startListening

StartServiceAt(Me, DateTime.Now + 5000, True)
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy
sr.cancel
sr.Destroy
End Sub

Sub sr_onResults(words As List)
sr.stopListening
Dim a As String
For Each word As String In words
	'a = a & CRLF & word
   If word ="alarm" Then 
   	StopService(Me)
CancelScheduledService(Me)
	End If
   Log(word)
Next
ToastMessageShow(a, True)
sr.stopListening
'StartActivity(Main)



End Sub

'An error has occured.
Sub sr_onError(ErrorType As Int)
Log("SR_Error: " & ErrorType)
Log(sr.GetErrorText(ErrorType))

If ErrorType = 6 Then	'No speech input
	Log("Error: " & ErrorType)
    CallSub2(Main, "ShowError", ErrorType) 
	StartActivity(Main)
	ToastMessageShow("No speech input", False)
End If
End Sub


Sub sr_onEndOfSpeech
End Sub

Sub sr_onRmsChanged(rmsdB As Float)
If rmsdB > 8 Then
	Log("RMS=" & rmsdB)
End If
End Sub
