package b4a.example;


import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.objects.ServiceHelper;
import anywheresoftware.b4a.debug.*;

public class starter extends android.app.Service {
	public static class starter_BR extends android.content.BroadcastReceiver {

		@Override
		public void onReceive(android.content.Context context, android.content.Intent intent) {
			android.content.Intent in = new android.content.Intent(context, starter.class);
			if (intent != null)
				in.putExtra("b4a_internal_intent", intent);
			context.startService(in);
		}

	}
    static starter mostCurrent;
	public static BA processBA;
    private ServiceHelper _service;
    public static Class<?> getObject() {
		return starter.class;
	}
	@Override
	public void onCreate() {
        mostCurrent = this;
        if (processBA == null) {
		    processBA = new BA(this, null, null, "b4a.example", "b4a.example.starter");
            try {
                Class.forName(BA.applicationContext.getPackageName() + ".main").getMethod("initializeProcessGlobals").invoke(null, null);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
            processBA.loadHtSubs(this.getClass());
            ServiceHelper.init();
        }
        _service = new ServiceHelper(this);
        processBA.service = this;
        processBA.setActivityPaused(false);
        if (BA.isShellModeRuntimeCheck(processBA)) {
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.starter", processBA, _service);
		}
        BA.LogInfo("** Service (starter) Create **");
        processBA.raiseEvent(null, "service_create");
        processBA.runHook("oncreate", this, null);
    }
		@Override
	public void onStart(android.content.Intent intent, int startId) {
		handleStart(intent);
    }
    @Override
    public int onStartCommand(android.content.Intent intent, int flags, int startId) {
    	handleStart(intent);
        processBA.runHook("onstartcommand", this, new Object[] {intent, flags, startId});
		return android.app.Service.START_NOT_STICKY;
    }
    private void handleStart(android.content.Intent intent) {
    	BA.LogInfo("** Service (starter) Start **");
    	java.lang.reflect.Method startEvent = processBA.htSubs.get("service_start");
    	if (startEvent != null) {
    		if (startEvent.getParameterTypes().length > 0) {
    			anywheresoftware.b4a.objects.IntentWrapper iw = new anywheresoftware.b4a.objects.IntentWrapper();
    			if (intent != null) {
    				if (intent.hasExtra("b4a_internal_intent"))
    					iw.setObject((android.content.Intent) intent.getParcelableExtra("b4a_internal_intent"));
    				else
    					iw.setObject(intent);
    			}
    			processBA.raiseEvent(null, "service_start", iw);
    		}
    		else {
    			processBA.raiseEvent(null, "service_start");
    		}
    	}
    }
	@Override
	public android.os.IBinder onBind(android.content.Intent intent) {
		return null;
	}
	@Override
	public void onDestroy() {
        BA.LogInfo("** Service (starter) Destroy **");
		processBA.raiseEvent(null, "service_destroy");
        processBA.service = null;
		mostCurrent = null;
		processBA.setActivityPaused(true);
        processBA.runHook("ondestroy", this, null);
	}
public anywheresoftware.b4a.keywords.Common __c = null;
public static b4a.example.speechrecognition _sr = null;
public b4a.example.main _main = null;
public static boolean  _application_error(anywheresoftware.b4a.objects.B4AException _error,String _stacktrace) throws Exception{
 //BA.debugLineNum = 55;BA.debugLine="Sub Application_Error (Error As Exception, StackTr";
 //BA.debugLineNum = 56;BA.debugLine="Return True";
if (true) return anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 57;BA.debugLine="End Sub";
return false;
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 6;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 9;BA.debugLine="Dim sr As SpeechRecognition";
_sr = new b4a.example.speechrecognition();
 //BA.debugLineNum = 10;BA.debugLine="End Sub";
return "";
}
public static String  _service_create() throws Exception{
 //BA.debugLineNum = 12;BA.debugLine="Sub Service_Create";
 //BA.debugLineNum = 15;BA.debugLine="sr.Initialize(Me, \"\", \"sr\")";
_sr._initialize(processBA,starter.getObject(),"","sr");
 //BA.debugLineNum = 20;BA.debugLine="End Sub";
return "";
}
public static String  _service_destroy() throws Exception{
 //BA.debugLineNum = 59;BA.debugLine="Sub Service_Destroy";
 //BA.debugLineNum = 60;BA.debugLine="sr.cancel";
_sr._cancel();
 //BA.debugLineNum = 61;BA.debugLine="sr.Destroy";
_sr._destroy();
 //BA.debugLineNum = 62;BA.debugLine="End Sub";
return "";
}
public static String  _service_start(anywheresoftware.b4a.objects.IntentWrapper _startingintent) throws Exception{
anywheresoftware.b4a.phone.Phone _p = null;
int _volu1 = 0;
long _wticks1 = 0L;
long _wticks2 = 0L;
 //BA.debugLineNum = 22;BA.debugLine="Sub Service_Start (StartingIntent As Intent)";
 //BA.debugLineNum = 23;BA.debugLine="If sr.IsRecognitionAvailable = False Then";
if (_sr._isrecognitionavailable()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 24;BA.debugLine="Return";
if (true) return "";
 };
 //BA.debugLineNum = 26;BA.debugLine="ToastMessageShow(\"Speak !\", False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Speak !",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 30;BA.debugLine="Dim p As Phone              'Suppress Google Voi";
_p = new anywheresoftware.b4a.phone.Phone();
 //BA.debugLineNum = 31;BA.debugLine="Dim Volu1 As Int";
_volu1 = 0;
 //BA.debugLineNum = 32;BA.debugLine="Dim Wticks1 As Long";
_wticks1 = 0L;
 //BA.debugLineNum = 33;BA.debugLine="Dim Wticks2 As Long";
_wticks2 = 0L;
 //BA.debugLineNum = 35;BA.debugLine="Volu1 = p.GetVolume(p.VOLUME_MUSIC)";
_volu1 = _p.GetVolume(_p.VOLUME_MUSIC);
 //BA.debugLineNum = 36;BA.debugLine="p.SetVolume(p.VOLUME_MUSIC, 0, False)";
_p.SetVolume(_p.VOLUME_MUSIC,(int) (0),anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 38;BA.debugLine="sr.startListening";
_sr._startlistening();
 //BA.debugLineNum = 40;BA.debugLine="Wticks1 = DateTime.Now";
_wticks1 = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 //BA.debugLineNum = 41;BA.debugLine="Wticks2 = 0";
_wticks2 = (long) (0);
 //BA.debugLineNum = 42;BA.debugLine="Do While Wticks2 < (Wticks1+800)";
while (_wticks2<(_wticks1+800)) {
 //BA.debugLineNum = 43;BA.debugLine="Wticks2 = DateTime.Now";
_wticks2 = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 //BA.debugLineNum = 44;BA.debugLine="DoEvents";
anywheresoftware.b4a.keywords.Common.DoEvents();
 }
;
 //BA.debugLineNum = 46;BA.debugLine="p.SetVolume(p.VOLUME_MUSIC, Volu1, False)";
_p.SetVolume(_p.VOLUME_MUSIC,_volu1,anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 51;BA.debugLine="StartServiceAt(Me, DateTime.Now + 5000, True)";
anywheresoftware.b4a.keywords.Common.StartServiceAt(processBA,starter.getObject(),(long) (anywheresoftware.b4a.keywords.Common.DateTime.getNow()+5000),anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 52;BA.debugLine="End Sub";
return "";
}
public static String  _sr_onendofspeech() throws Exception{
 //BA.debugLineNum = 97;BA.debugLine="Sub sr_onEndOfSpeech";
 //BA.debugLineNum = 98;BA.debugLine="End Sub";
return "";
}
public static String  _sr_onerror(int _errortype) throws Exception{
 //BA.debugLineNum = 84;BA.debugLine="Sub sr_onError(ErrorType As Int)";
 //BA.debugLineNum = 85;BA.debugLine="Log(\"SR_Error: \" & ErrorType)";
anywheresoftware.b4a.keywords.Common.Log("SR_Error: "+BA.NumberToString(_errortype));
 //BA.debugLineNum = 86;BA.debugLine="Log(sr.GetErrorText(ErrorType))";
anywheresoftware.b4a.keywords.Common.Log(_sr._geterrortext(_errortype));
 //BA.debugLineNum = 88;BA.debugLine="If ErrorType = 6 Then	'No speech input";
if (_errortype==6) { 
 //BA.debugLineNum = 89;BA.debugLine="Log(\"Error: \" & ErrorType)";
anywheresoftware.b4a.keywords.Common.Log("Error: "+BA.NumberToString(_errortype));
 //BA.debugLineNum = 90;BA.debugLine="CallSub2(Main, \"ShowError\", ErrorType)";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._main.getObject()),"ShowError",(Object)(_errortype));
 //BA.debugLineNum = 91;BA.debugLine="StartActivity(Main)";
anywheresoftware.b4a.keywords.Common.StartActivity(processBA,(Object)(mostCurrent._main.getObject()));
 //BA.debugLineNum = 92;BA.debugLine="ToastMessageShow(\"No speech input\", False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("No speech input",anywheresoftware.b4a.keywords.Common.False);
 };
 //BA.debugLineNum = 94;BA.debugLine="End Sub";
return "";
}
public static String  _sr_onresults(anywheresoftware.b4a.objects.collections.List _words) throws Exception{
String _a = "";
String _word = "";
 //BA.debugLineNum = 64;BA.debugLine="Sub sr_onResults(words As List)";
 //BA.debugLineNum = 65;BA.debugLine="sr.stopListening";
_sr._stoplistening();
 //BA.debugLineNum = 66;BA.debugLine="Dim a As String";
_a = "";
 //BA.debugLineNum = 67;BA.debugLine="For Each word As String In words";
final anywheresoftware.b4a.BA.IterableList group37 = _words;
final int groupLen37 = group37.getSize();
for (int index37 = 0;index37 < groupLen37 ;index37++){
_word = BA.ObjectToString(group37.Get(index37));
 //BA.debugLineNum = 69;BA.debugLine="If word =\"alarm\" Then";
if ((_word).equals("alarm")) { 
 //BA.debugLineNum = 70;BA.debugLine="StopService(Me)";
anywheresoftware.b4a.keywords.Common.StopService(processBA,starter.getObject());
 //BA.debugLineNum = 71;BA.debugLine="CancelScheduledService(Me)";
anywheresoftware.b4a.keywords.Common.CancelScheduledService(processBA,starter.getObject());
 };
 //BA.debugLineNum = 73;BA.debugLine="Log(word)";
anywheresoftware.b4a.keywords.Common.Log(_word);
 }
;
 //BA.debugLineNum = 75;BA.debugLine="ToastMessageShow(a, True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(_a,anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 76;BA.debugLine="sr.stopListening";
_sr._stoplistening();
 //BA.debugLineNum = 81;BA.debugLine="End Sub";
return "";
}
public static String  _sr_onrmschanged(float _rmsdb) throws Exception{
 //BA.debugLineNum = 100;BA.debugLine="Sub sr_onRmsChanged(rmsdB As Float)";
 //BA.debugLineNum = 101;BA.debugLine="If rmsdB > 8 Then";
if (_rmsdb>8) { 
 //BA.debugLineNum = 102;BA.debugLine="Log(\"RMS=\" & rmsdB)";
anywheresoftware.b4a.keywords.Common.Log("RMS="+BA.NumberToString(_rmsdb));
 };
 //BA.debugLineNum = 104;BA.debugLine="End Sub";
return "";
}
}
